---

name: 🐛 Bug report
about: Create a report to help us improve
---

## 🐛 Bug Report

A clear and concise description of what the bug is.

<!-- NOTE
FIREFOX 48+ IS ONLY COMPATIBLE WITH GECKODRIVER.

If the issue is with Google Chrome consider logging an issue with chromedriver instead:
https://chromedriver.chromium.org/help

If the issue is with Firefox GeckoDriver (aka Marionette) consider logging an issue with Mozilla:
https://bugzilla.mozilla.org/buglist.cgi?product=Testing&component=Marionette

If the issue is with Microsoft Edge consider logging an issue with Microsoft instead:
https://developer.microsoft.com/en-us/microsoft-edge/platform/issues/

If the issue is with Safari, only Safari 10+ is supported. Please log any Safari issue with Apple:
https://bugreport.apple.com/

-->

## To Reproduce

<!--
Please be sure to include an SSCCE (Short, Self Contained, Correct [compilable] example) http://sscce.org/
If you can't provide a link to the page, consider creating a reproducible page on https://jsfiddle.net/
-->

Detailed steps to reproduce the behavior:

## Expected behavior

A clear and concise description of what you expected to happen.

## Test script or set of commands reproducing this issue

Please provide a test script to reproduce the issue you are reporting, if the 
setup is more complex, GitHub repo links with are also OK.

Issues without a reproduction script are likely to stall and eventually be closed.

## Environment

OS: <!-- Windows 10? OSX? -->
Browser: <!-- Chrome? Safari?  -->
Browser version: <!-- e.g.: 70.0.3538.110 -->
Browser Driver version: <!-- e.g.: ChromeDriver 2.43, GeckoDriver 0.23 -->
Language Bindings version: <!-- e.g.: Java 3.141.0 --> 
Selenium Grid version (if applicable): <!-- e.g.: 3.141.59 --> 
