#!/usr/bin/env ruby

require 'fileutils'
require 'rubygems/package'
require 'tmpdir'

gemspec = File.read('{gemspec}')
gem_file = File.expand_path('{gem_filename}', '{bazel_out_dir}')

def copy_srcs(from:, to:)
  Dir.chdir(from) do
    Dir.glob('**/*').each do |src|
      dst = File.join(to, src)
      if File.directory?(src)
        FileUtils.mkdir_p(dst)
      else
        FileUtils.cp(src, dst)
        # https://github.com/bazelbuild/bazel/issues/5588
        File.chmod(0o644, dst)
      end
    end
  end
end

Dir.mktmpdir do |tmpdir|
  # First copy files that live in gem directory.
  copy_srcs(from: File.dirname('{gemspec}'), to: tmpdir)
  # Then copy files generated by target dependencies.
  copy_srcs(from: '{bazel_out_dir}', to: tmpdir)

  Dir.chdir(tmpdir) do
    spec = eval(gemspec)
    file = Gem::Package.build(spec)
    FileUtils.mv(file, gem_file)
  end
end
